<?php

namespace App\DataTables;

use App\Models\Lang;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;

class LangDataTable extends DataTable
{
    /**
     * Build DataTable class.
     *
     * @param mixed $query Results from query() method.
     * @return \Yajra\DataTables\DataTableAbstract
     */
    public function dataTable($query)
    {
        return datatables()
            ->eloquent($query)
            ->addColumn('created_at',function($lang){
                return $lang->created_at->format('Y-m-d h:i a');
            })
            ->addColumn('action', function($lang){
                $action = view('components.edit-link', ['href'=>route('localization.show',$lang->id)]);
                $action .= view('components.destroy-link', ['href'=>route('localization.destroy',$lang->id)]);
                return $action;
            });
    }

    /**
     * Get query source of dataTable.
     *
     * @param \App\Models\Lang $model
     * @return \Illuminate\Database\Eloquent\Builder
     */
    public function query(Lang $model)
    {
        return $model->newQuery();
    }

    /**
     * Optional method if you want to use html builder.
     *
     * @return \Yajra\DataTables\Html\Builder
     */
    public function html()
    {
        return $this->builder()
                    ->setTableId('lang-table')
                    ->columns($this->getColumns())
                    ->minifiedAjax()
                    ->dom('Bfrtip')
                    ->orderBy(1)
                    ->buttons(
                        Button::make('export'),
                        Button::make('print'),
                        Button::make('reset'),
                        Button::make('reload')
                    );
    }

    /**
     * Get columns.
     *
     * @return array
     */
    protected function getColumns()
    {
        return [
            Column::make('id')->title(__('Id')),
            Column::make('locale')->title(__('Locale')),
            Column::make('key')->title(__('Key')),
            Column::make('value')->title(__('Value')),
            Column::make('created_at')->title(__('Created At')),
            Column::computed('action')->title(__('Action'))
            ->exportable(false)
            ->printable(false)
            ->width(150)
            ->addClass('text-center'),
        ];
    }

    /**
     * Get filename for export.
     *
     * @return string
     */
    protected function filename()
    {
        return 'Lang_' . date('YmdHis');
    }
}
